%define pkg       distcache
%define ver       1.5.2
%define rel       dev


Summary:          A distributed SSL session cache
Name:             %{pkg}
Version:          %{ver}
Release:          0.1.%{rel}%{?dist}%{?pext}
License:          LGPL
Group:            Environment/Daemons
Source0:          http://downloads.sourceforge.net/project/%{pkg}/%{pkg}-devel/%{ver}/%{pkg}-%{ver}%{rel}.tar.gz
Source1:          dc_client.init
Source2:          dc_server.init
Source3:          %{pkg}.sysconfig
Patch0:           %{pkg}-1.5.2-build.patch
Patch1:           %{pkg}-1.5.2-memleak.patch
URL:              http://%{pkg}.sourceforge.net/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           The Distcache.org Project
Requires:         %{name}-lib = %{version}-%{release}
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service
BuildRequires:    openssl-devel

%description
The Distcache package provides a variety of functionality for enabling a
network-based session caching system, primarily for (though not restricted
to) SSL/TLS session caching.


%package          devel
Summary:          Development tools for Distcache
Group:            Development/Libraries
Requires:         %{name}-lib = %{version}-%{release}
Requires:         openssl-devel

%description      devel
The %{name}-devel package contains the libraries and header files for
developing software using the distributed SSL session cache.


%package          lib
Summary:          Libraries used by Distcache
Group:            System Environment/Libraries

%description      lib
The %{name}-lib package contains all runtime libraries used by the
distributed SSL session cache and its clients.


%package          static
Summary:          Static libraries for Distcache
Group:            Development/Libraries
Requires:         %{name}-devel = %{version}-%{release}

%description      static
The %{name}-static package contains the statically linkable libraries
for the distributed SSL session cache.


%prep
%setup -q -n %{pkg}-%{ver}%{rel}
%patch0 -p1
%patch1 -p0


%build
%configure \
	--enable-shared \
	--enable-static \
	--with-ssl=%{_prefix}

%{__make} %{?_smp_mflags}


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__install} -m 0755 %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/dc_client
%{__install} -m 0755 %{SOURCE2} ${RPM_BUILD_ROOT}%{_initrddir}/dc_server
%{__install} -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{pkg}

# Cleanup
%{__rm} -f ${RPM_BUILD_ROOT}%{_bindir}/{nal*,piper}
%{__rm} -f ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.?


%pre
if ! getent group  %{pkg} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r -g 94 %{pkg}
fi
if ! getent passwd %{pkg} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -u 94 -g %{pkg}   \
	-d / -c "Distcache Service user"  \
	-M -s /sbin/nologin %{pkg}
fi
exit 0			# Always pass


%post
/sbin/chkconfig --add dc_client
/sbin/chkconfig --add dc_server

%post lib -p /sbin/ldconfig


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service dc_client stop >/dev/null 2>&1
  /sbin/service dc_server stop >/dev/null 2>&1

  /sbin/chkconfig --del dc_client
  /sbin/chkconfig --del dc_server
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service dc_client condrestart >/dev/null 2>&1 || :
  /sbin/service dc_server condrestart >/dev/null 2>&1 || :
fi

%postun lib -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc ANNOUNCE BUGS CHANGES FAQ
%doc INSTALL LICENSE README
%{_initrddir}/dc_client
%{_initrddir}/dc_server
%config(noreplace) %{_sysconfdir}/sysconfig/%{pkg}
%{_bindir}/dc_client
%{_bindir}/dc_server
%{_bindir}/dc_snoop
%{_bindir}/dc_test
%{_bindir}/sslswamp
%{_datadir}/swamp
%{_mandir}/man1/dc_client.1*
%{_mandir}/man1/dc_server.1*
%{_mandir}/man1/dc_snoop.1*
%{_mandir}/man1/dc_test.1*
%{_mandir}/man1/sslswamp.1*
%{_mandir}/man8/distcache.8*

%files devel
%defattr(-,root,root)
%{_includedir}/%{pkg}
%{_includedir}/libnal
%{_libdir}/libdistcache*.la
%{_libdir}/libdistcache*.so
%{_libdir}/libnal*.la
%{_libdir}/libnal*.so
%{_mandir}/man2/DC_*.2*
%{_mandir}/man2/NAL_*.2*

%files lib
%defattr(-,root,root)
%{_libdir}/libdistcache*.so.*
%{_libdir}/libnal*.so.*

%files static
%defattr(-,root,root)
%{_libdir}/libdistcache*.a
%{_libdir}/libnal*.a


%changelog
* Sun Feb 23 2014 Peter Pramberger <peterpramb@member.fsf.org> - 1.5.2-0.1.dev
- Initial build
